summaryrefslogtreecommitdiff
path: root/travis-ci/managers/debian.sh
diff options
context:
space:
mode:
Diffstat (limited to 'travis-ci/managers/debian.sh')
-rwxr-xr-xtravis-ci/managers/debian.sh98
1 files changed, 0 insertions, 98 deletions
diff --git a/travis-ci/managers/debian.sh b/travis-ci/managers/debian.sh
deleted file mode 100755
index 39fbb3d65c..0000000000
--- a/travis-ci/managers/debian.sh
+++ /dev/null
@@ -1,98 +0,0 @@
-#!/bin/bash
-
-# Run this script from the root of the systemd's git repository
-# or set REPO_ROOT to a correct path.
-#
-# Example execution on Fedora:
-# dnf install docker
-# systemctl start docker
-# export CONT_NAME="my-fancy-container"
-# travis-ci/managers/debian.sh SETUP RUN CLEANUP
-
-PHASES=(${@:-SETUP RUN RUN_ASAN_UBSAN CLEANUP})
-DEBIAN_RELEASE="${DEBIAN_RELEASE:-testing}"
-CONT_NAME="${CONT_NAME:-systemd-debian-$DEBIAN_RELEASE}"
-DOCKER_EXEC="${DOCKER_EXEC:-docker exec -it $CONT_NAME}"
-DOCKER_RUN="${DOCKER_RUN:-docker run}"
-REPO_ROOT="${REPO_ROOT:-$PWD}"
-ADDITIONAL_DEPS=(
- clang
- fdisk
- libfdisk-dev
- libfido2-dev
- libp11-kit-dev
- libpwquality-dev
- libqrencode-dev
- libssl-dev
- libtss2-dev
- libzstd-dev
- perl
- python3-libevdev
- python3-pyparsing
- zstd
-)
-
-function info() {
- echo -e "\033[33;1m$1\033[0m"
-}
-
-set -e
-
-source "$(dirname $0)/travis_wait.bash"
-
-for phase in "${PHASES[@]}"; do
- case $phase in
- SETUP)
- info "Setup phase"
- info "Using Debian $DEBIAN_RELEASE"
- printf "FROM debian:$DEBIAN_RELEASE\nRUN bash -c 'apt-get -y update && apt-get install -y systemd'\n" | docker build -t debian-with-systemd/latest -
- info "Starting container $CONT_NAME"
- $DOCKER_RUN -v $REPO_ROOT:/build:rw -e container=docker \
- -w /build --privileged=true --name $CONT_NAME \
- -dit --net=host debian-with-systemd/latest /bin/systemd
- $DOCKER_EXEC bash -c "echo deb-src http://deb.debian.org/debian $DEBIAN_RELEASE main >>/etc/apt/sources.list"
- # Wait for the container to properly boot up, otherwise we were
- # running following apt-get commands during the initializing/starting
- # (early/late bootup) phase, which caused nasty race conditions
- $DOCKER_EXEC bash -c 'systemctl is-system-running --wait || :'
- $DOCKER_EXEC apt-get -y update
- $DOCKER_EXEC apt-get -y build-dep systemd
- $DOCKER_EXEC apt-get -y install "${ADDITIONAL_DEPS[@]}"
- ;;
- RUN|RUN_GCC|RUN_CLANG)
- if [[ "$phase" = "RUN_CLANG" ]]; then
- ENV_VARS="-e CC=clang -e CXX=clang++"
- fi
- docker exec $ENV_VARS -it $CONT_NAME meson --werror -Dtests=unsafe -Dslow-tests=true -Dfuzz-tests=true -Dsplit-usr=true -Dman=true build
- $DOCKER_EXEC ninja -v -C build
- docker exec -e "TRAVIS=$TRAVIS" -it $CONT_NAME ninja -C build test
- ;;
- RUN_ASAN_UBSAN|RUN_GCC_ASAN_UBSAN|RUN_CLANG_ASAN_UBSAN)
- if [[ "$phase" = "RUN_CLANG_ASAN_UBSAN" ]]; then
- ENV_VARS="-e CC=clang -e CXX=clang++"
- # Build fuzzer regression tests only with clang (for now),
- # see: https://github.com/systemd/systemd/pull/15886#issuecomment-632689604
- # -Db_lundef=false: See https://github.com/mesonbuild/meson/issues/764
- MESON_ARGS="-Db_lundef=false -Dfuzz-tests=true --optimization=1"
- fi
- docker exec $ENV_VARS -it $CONT_NAME meson --werror -Dtests=unsafe -Db_sanitize=address,undefined -Dsplit-usr=true $MESON_ARGS build
- $DOCKER_EXEC ninja -v -C build
-
- # Never remove halt_on_error from UBSAN_OPTIONS. See https://github.com/systemd/systemd/commit/2614d83aa06592aedb.
- travis_wait docker exec --interactive=false \
- -e UBSAN_OPTIONS=print_stacktrace=1:print_summary=1:halt_on_error=1 \
- -e ASAN_OPTIONS=strict_string_checks=1:detect_stack_use_after_return=1:check_initialization_order=1:strict_init_order=1 \
- -e "TRAVIS=$TRAVIS" \
- -t $CONT_NAME \
- meson test --timeout-multiplier=3 -C ./build/ --print-errorlogs
- ;;
- CLEANUP)
- info "Cleanup phase"
- docker stop $CONT_NAME
- docker rm -f $CONT_NAME
- ;;
- *)
- echo >&2 "Unknown phase '$phase'"
- exit 1
- esac
-done